-- anti sneaker smuggling lua because god I hate people hanging on to sneakers for hours
-- freeman#7626 reuse and mangle as required

freeslot("sfx_warndr")

local cv_antismuggla = CV_RegisterVar({
	name = "wa_antismuggla",
	defaultvalue = "on",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff
}) -- controls on/off

local cv_antismuggla_time = CV_RegisterVar({
	name = "wa_antismuggla_time",
	defaultvalue = 350,
	flags = CV_NETVAR,
	possiblevalue = CV_Natural
}) -- how long (tics) you have to be in first before antismuggla drops your shit - 35 = 1 second

local cv_antismuggla_dist = CV_RegisterVar({
	name = "wa_antismuggla_dist",
	defaultvalue = 1000,
	flags = CV_NETVAR,
	possiblevalue = CV_Natural
}) -- A configurable distance before antismuggla starts rapid draining duration items

local cv_antismuggla_drainrate = CV_RegisterVar({
	name = "wa_antismuggla_drainrate",
	defaultvalue = 3,
	flags = CV_NETVAR,
	possiblevalue = CV_Natural
}) -- A configurable distance before antismuggla starts rapid draining duration items

local cv_antismuggla_drain_time = CV_RegisterVar({
    name = "antismuggla_drain_time",
    defaultvalue = 105,
    flags = CV_NETVAR,
    possiblevalue = CV_Unsigned,
}) -- Time before starting to drain power items

local cv_antismuggla_drain = CV_RegisterVar({
    name = "wa_antismuggla_drain",
    defaultvalue = "On",
    flags = CV_NETVAR,
    possiblevalue = CV_OnOff,
}) -- Drain item duration?

local cv_antismuggla_drop = CV_RegisterVar({
    name = "wa_antismuggla_drop",
    defaultvalue = "Off",
    flags = CV_NETVAR,
    possiblevalue = CV_OnOff,
}) -- Drop items?

local cv_combi, cv_frontrun, cv_driftnitro

local function findGamemodeCvars()
    if not cv_combi then cv_combi = CV_FindVar("combi_active") end
    if not cv_frontrun then cv_frontrun = CV_FindVar("frontrun_enabled") end
    if not cv_driftnitro then cv_driftnitro = CV_FindVar("driftnitro") end
end

local function set(t)
    local result = {}
    
    for i = 1, #t do
        result[t[i]] = true
    end
    
    return result
end

local drop_items = set {
    KITEM_SNEAKER,
    KITEM_ROCKETSNEAKER,
    KITEM_INVINCIBILITY,
    KITEM_GROW,
}

local AS_ACTIVE = 1
local AS_DRAIN = 2
local AS_DROP = 4

local antismuggla = 0

addHook("MapLoad", function()
	antismuggla = cv_antismuggla.value | (cv_antismuggla_drain.value << 1) | (cv_antismuggla_drop.value << 2)
end)

addHook("NetVars", function(net)
	antismuggla = net($)
end)

addHook("MapLoad", findGamemodeCvars)
addHook("NetVars", findGamemodeCvars)

local playercount = 0
addHook("ThinkFrame", function()
    if G_BattleGametype() then return end
	if not (antismuggla & AS_ACTIVE) then return end
	--Disable this for various modes
	if cv_combi and cv_combi.value == 1 then return end
	if cv_frontrun and cv_frontrun.value == 1 then return end
	if cv_driftnitro and cv_driftnitro.value == 1 then return end

	--Get player count before running anything below
	if (playercount == 0) or leveltime % (10*TICRATE) == 0 then --Cache this result in order to reduce the amount of looping this is doing in the background
		playercount = 0 --Reset
		for p in players.iterate do
			if not p.spectator then
				playercount = $+1
				if playercount > 1 then break end --Exit early, this is the only relevant data
			end
		end
	end

	--Only run this if multiple people are playing
	if playercount > 1 then
		local secondplace = nil
	
		for p in players.iterate do
			if not p.mo then continue end
			if p.kartstuff[k_position] > 1 then continue end --This script doesn't care about anyone not in first so get out of it ASAP
			if p.antismugglatimer == nil then p.antismugglatimer = 0 end
            if p.antismuggla_drain_timer == nil then p.antismuggla_drain_timer = 0 end

			if secondplace == nil then
				for q in players.iterate do
					if not q.spectator and q.kartstuff[k_position] == 2 then
						secondplace = q
						break
					end
				end
			end
			
			local maxdist = FixedMul(mapobjectscale, cv_antismuggla_dist.value*FRACUNIT)
			local dist = 0
			
			if secondplace ~= nil then
				dist = abs(FixedHypot(FixedHypot(p.mo.x - secondplace.mo.x, p.mo.y - secondplace.mo.y),p.mo.z - secondplace.mo.z))
			end

			-- rapidly drain duration items if defined distance fracs ahead of second place
			if (antismuggla & AS_DRAIN) and dist > maxdist
                and (p.kartstuff[k_rocketsneakertimer] or p.kartstuff[k_invincibilitytimer] or p.kartstuff[k_growshrinktimer] or p.kartstuff[k_hyudorotimer]) then
				
				p.antismuggla_drain_timer = p.antismuggla_drain_timer + 1
				
				local timer = p.antismuggla_drain_timer
				
				if timer > cv_antismuggla_drain_time.value then
					-- Checking all of these at once in case of item stacking
					if p.kartstuff[k_rocketsneakertimer] then
						p.kartstuff[k_rocketsneakertimer] = max(1,$-cv_antismuggla_drainrate.value)
					end
					if p.kartstuff[k_invincibilitytimer] then
						p.kartstuff[k_invincibilitytimer] = max(1,$-cv_antismuggla_drainrate.value)
					end
					if p.kartstuff[k_growshrinktimer] then
						p.kartstuff[k_growshrinktimer] = max(1,$-cv_antismuggla_drainrate.value)
					end
					if p.kartstuff[k_hyudorotimer] then
						p.kartstuff[k_hyudorotimer] = max(1,$-cv_antismuggla_drainrate.value)
					end
					
					if timer % 8 == 0 then
						S_StartSound(p.mo, sfx_s3k78)
					end
					
					if timer % 4 == 0 then
						for i = 1, 4 do
							local particle = P_SpawnMobj(p.mo.x, p.mo.y, p.mo.z, MT_THOK)
							particle.fuse = 8
							particle.sprite = SPR_KINV
							particle.frame = G
							particle.color = p.mo.color
							P_InstaThrust(particle, P_RandomRange(0, 360)*ANG1, 30*FRACUNIT)
							particle.momz = P_RandomRange(-30, 30)*FRACUNIT
						end
					end
					
				elseif p.antismuggla_drain_timer % (TICRATE/2) == 0 then
					S_StartSound(nil, sfx_warndr, p)
				end
			else
                p.antismuggla_drain_timer = max(min(p.antismuggla_drain_timer - 1, cv_antismuggla_drain_time.value+1), 0)
            end

			-- drop sneakers, grow, or invuln if held in first for longer than configured
			if (antismuggla & AS_DROP) and dist > maxdist and (drop_items[p.kartstuff[k_itemtype]]) then
                if p.antismugglatimer >= cv_antismuggla_time.value then
					K_DropItems(p)
					S_StartSound(nil, sfx_shldls, p)
				else -- otherwise, we were not prepared to drop anyways
					p.antismugglatimer = $+1
					p.antismuggla = true
					if p.antismugglatimer == 1 then -- first frame in first with an item
						S_StartSound(nil, sfx_buzz1, p)
					elseif p.antismugglatimer%35 == 0 then
						S_StartSound(nil, sfx_ding, p)
					end
				end
			elseif p.antismugglatimer > 0 then
				p.antismugglatimer = $-1
				p.antismuggla = false
			end
		end
	end
end)

local smugx,smugy = 22,17

-- Funny HUD + Helpers
local function countActiveSplitScreenPlayers()
	local number = 0

	for p in displayplayers.iterate do
		number = $ + 1
	end

	return number
end

local function whichSplitscreenPlayerIsThis(thisPlayer)
	local number = 1
	local howManyPlayers = countActiveSplitScreenPlayers()

	if howManyPlayers == number then return number
	elseif howManyPlayers > 1 then
		for p in displayplayers.iterate do
			if p == thisPlayer then break
			else number = $ + 1
			end
		end
	end

	return number
end

--Kind of redundant for this purpose but whatever
local function isPlayerItemBoxOccupied(player)

	if 	player.kartstuff[k_itemroulette] 	> 0 or 	-- under any roulette
		player.kartstuff[k_eggmanexplode]	> 0 or	-- getting eggman'd
		player.kartstuff[k_itemtype]       ~= 0	or	-- has item (-1 is sad face)
		player.kartstuff[k_curshield]		> 0 or	-- using thunder shield
		player.kartstuff[k_stealingtimer] 	> 0 or 	-- stealing something
		player.kartstuff[k_stolentimer]		> 0 or 	-- getting stolen from
		player.kartstuff[k_growshrinktimer] > 0 or  -- beeg
		player.kartstuff[k_rocketsneakertimer] > 0 or -- rocket sneakers
		player.kartstuff[k_itemheld] == true then	-- dragging/deployed item

		return true
	end

	return false
end

local eggn
hud.add(function(v, p, c) --I HATE HUD CODE I HATE HUD CODE
	if splitscreen then return end --lmao
    
    if not eggn then
        eggn = {}
        
        for i = 0, 10 do
            eggn[i] = v.cachePatch("K_EGGN"..i)
        end
    end
	
	if not p then return end --paranoia
    
	if (p.antismuggla and p.antismugglatimer and p.antismugglatimer > 0) and
		(p.kartstuff[k_itemtype] == KITEM_SNEAKER or p.kartstuff[k_itemtype] == KITEM_INVINCIBILITY or p.kartstuff[k_itemtype] == KITEM_GROW)
		and p.kartstuff[k_position] <= 1 then

		local struggletimer = max(cv_antismuggla_time.value - p.antismugglatimer, 0)
		
		if struggletimer <= 12*TICRATE then
			local smugflags = V_SNAPTOTOP|V_SNAPTOLEFT
			
			local transparency = v.localTransFlag()>>V_ALPHASHIFT
			
			if leveltime%8 >= 4 then
				transparency = min($ + 3, 9)
			end
			
			smugflags = $ | (transparency<<V_ALPHASHIFT)
			
			local patch_num = (struggletimer-1)/TICRATE
			
			if eggn[patch_num] then
				v.draw(smugx, smugy, eggn[patch_num], smugflags)
			end
		end
	end

	--TODO - Draw timer bar for how long Grow+Invuln has remaining
	if p.kartstuff[k_invincibilitytimer] or p.kartstuff[k_growshrinktimer] or p.kartstuff[k_hyudorotimer] then
		local splitscreenNum = countActiveSplitScreenPlayers()

		local barX		= 1000
		local barY 		= 1000
		local barWidth 	= 0

		-- we move barY down if player has item/roulette/held/growth timer
		if isPlayerItemBoxOccupied(p) then
			barY = $ + 1000
		end

		local flags		= V_SNAPTOTOP|V_HUDTRANS;
		local thisPlayer = whichSplitscreenPlayerIsThis(p)
		if splitscreenNum > 1 then -- more than one
			if splitscreenNum == 2 then 	-- 2 players
				flags = $|V_SNAPTOLEFT

				if thisPlayer == 2 then
					barY = $ + 106 			-- half the regular height + 8 offset pixels.
				end

			elseif splitscreenNum > 2 then	-- more than 2
				-- base pos values as ref. to the the smol item boxes
				barX 		= $ / 2
				barY 		= $ / 2
				barWidth 	= $ / 2 -- make it smol like the item box

				-- the hud snaps to the right on players 2 and 4
				-- left otherwise
				if thisPlayer % 2 == 0 then
					flags = $|V_SNAPTORIGHT
					barX  = 320 - barWidth - $
				else
					flags = $|V_SNAPTOLEFT
				end

				-- players 3 and 4 (lower ones) have their regular weird offset.
				if thisPlayer >= 3 then barY = $ + 108 end
			end
		else flags = $|V_SNAPTOLEFT
		end

		local timer = 0
		local maxDuration = 0
		if p.kartstuff[k_invincibilitytimer] then
			timer = p.kartstuff[k_invincibilitytimer] -- 10 seconds - 10*TICRATE
			maxDuration = 10*TICRATE
		elseif p.kartstuff[k_growshrinktimer] then
			timer = p.kartstuff[k_growshrinktimer] -- 12 seconds - 12*TICRATE
			maxDuration = 12*TICRATE
		elseif  p.kartstuff[k_hyudorotimer] then
			timer = p.kartstuff[k_hyudorotimer]  -- 7 seconds base, 14 seconds kartmp - 7*TICRATE/14*TICRATE
			maxDuration = 14*TICRATE
		end

		if timer > 0 then
			local funnyCalc1 = FixedMul(FixedDiv(FixedDiv((barWidth * 100) * FRACUNIT, maxDuration * FRACUNIT), 100 * FRACUNIT), timer * FRACUNIT)

			local visualTimer = FixedInt(funnyCalc1)

			--This makes it go UP, not down
			--local barActualWidth = barWidth - visualTimer

			-- bg
			v.drawFill(barX, 	barY-1, barWidth, 		1, 21|flags)
			v.drawFill(barX-1, 	barY, 	barWidth + 2, 	1, 23|flags)
			v.drawFill(barX-1, 	barY+1, barWidth + 2, 	1, 24|flags)
			v.drawFill(barX-1, 	barY+2, barWidth + 2, 	1, 25|flags)
			v.drawFill(barX, 	barY+3, barWidth, 		1, 26|flags)
			-- these parts move
			--v.drawFill(barX+1, 	barY, 	barActualWidth - 2, 1, 7|flags)
			--v.drawFill(barX, 	barY+1, barActualWidth, 	1, 9|flags)
			--v.drawFill(barX+1, 	barY+2, barActualWidth - 2, 1, 12|flags)
			v.drawFill(barX+1, 	barY, 	visualTimer - 2, 1, 7|flags)
			v.drawFill(barX, 	barY+1, visualTimer, 	1, 9|flags)
			v.drawFill(barX+1, 	barY+2, visualTimer - 2, 1, 12|flags)
		end
	end
end)

local function netvars(net)
	playercount = net($)
end
addHook("NetVars", netvars)
