local booststack = booststack

local cv_acrostack = CV_RegisterVar({
    name = "booststack_acro_support",
    defaultvalue = "On",
    possiblevalue = CV_OnOff,
    flags = CV_NETVAR,
})

local function rescale(val, oldmin, oldmax, newmin, newmax)
    return newmin + FixedMul(FixedDiv(val-oldmin, oldmax-oldmin), newmax-newmin)
end

booststack.registerBoostType("acrobasicsboost", {
    stackable = false,
    hidden = true,
    dynamic = true,
    
    getBoostPower = function(pmo)
        local player = pmo.player
		local speedboost, accelboost
		
		if player.acrostuff then
			local as = player.acrostuff
			
			speedboost = rescale(player.kartspeed*FRACUNIT, 9*FRACUNIT, FRACUNIT, 3*FRACUNIT/20, 3*FRACUNIT/8)
			speedboost = $*(min(as.chaincount, 4))
			
			accelboost = 4*FRACUNIT
		else
			speedboost = player.finaltrickboost or 0
			accelboost = 4*FRACUNIT
		end
    
        return speedboost, accelboost
    end,
})

addHook("MobjThinker", function(pmo)
    if not (booststack.running and cv_acrostack.value) then return end

    local p = pmo.player

    if p.trickboost then
        booststack.doBoost(pmo, "acrobasicsboost", 1, true)
    end
    
    pmo.as_trickboost = p.trickboost
end, MT_PLAYER)